"use strict";
exports.__esModule = true;
var cssRegExp_1 = require("../../runtime/cssRegExp");
exports["default"] = (function (_a, options) {
    var quasis = _a.quasis, expressions = _a.expressions;
    var substitutionNames = expressions.map(function (_, index) { return "__substitution-" + index + "__"; });
    var quasiValue = function (quasi) {
        var value = quasi.value.cooked;
        if (options != null && options.globals != null) {
            value = value.replace(cssRegExp_1.varRegExp, function (fullMatch, variable, fallback) {
                if (options.globals[variable] != null) {
                    return options.globals[variable];
                }
                else if (fallback) {
                    return fallback;
                }
                else if (!options.globalVarsOnly) {
                    return fullMatch;
                }
                else {
                    throw new Error("Found variable \"" + variable + "\". This was not defined in the globals, and `globalVarsOnly` is enabled. See line with `var(--" + variable + ")`");
                }
            });
        }
        return value;
    };
    var cssText = quasiValue(quasis[0]) +
        substitutionNames
            .map(function (name, index) { return name + quasiValue(quasis[index + 1]); })
            .join("");
    var substitutionMap = {};
    substitutionNames.forEach(function (substitution, index) {
        substitutionMap[substitution] = expressions[index];
    });
    return { cssText: cssText, substitutionMap: substitutionMap };
});
